<?php 
require_once('Basededatos.php');

class Caja extends Database
{
    
	public function Caja()
	{
 		parent::Database();
 		
	}

	
	


 public static function guardar($id_usuario,$nombre_caja,$monto_abrir)
  {
    	 try{
		    $consulta="INSERT caja (id_usuario,caja,monto_abrir,estado)
			values(?,?,?,?)";
		    $comando=parent::getInstance()->getDb()->prepare($consulta);
		    $comando->execute(array($id_usuario,$nombre_caja,$monto_abrir,'Abierta'));
		    
		    return true;
		    }catch(PDOException $e)
		    { 
				echo $e;
		      return false;
		    }
   		
    

  }

  /**
	* Obtiene el nro y contraseña para loguearse
	* a la base de datos
	* @param $nro    nro del usuario
	* @param $password    contraseña del usuario
	*/
 public static function cerrar_caja($id,$id_usuario,$monto_cierre)
 {
 
     try{
	    $consulta="UPDATE caja 
	    set   
		monto_cierre=?,
		estado=?,
		fecha_cierre=now()  
	    where id=? 
	    and id_usuario=?";

	    $comando=parent::getInstance()->getDb()->prepare($consulta);
	    $comando->execute(array($monto_cierre,'Cerrada',$id,$id_usuario));
	    return true;
    }catch(PDOException $e)
    { //echo $e;
      return false;
    }
}

 
  public  function caja_por_id($id)
   {  
   	$resultado=-1;
	try{
			$query = parent::getInstance()->getDb()->prepare("SELECT *, (tabla.monto_abrir+(tabla.monto_cuota)-tabla.monto_cuenta-tabla.monto_gasto+tabla.monto_abono) as monto_cierre
			from(select c.id,c.caja,
			c.monto_abrir ,
			case when (select sum(c1.monto) from cuota  c1 where c1.id_caja=c.id) is null then 0 else (select sum(c1.monto) from cuota  c1 where c1.id_caja=c.id) end as monto_cuota,
			case when (select sum(c3.valor) from cuenta  c3 where c3.id_caja=c.id) is null then 0 else (select sum(c3.valor) from cuenta  c3 where c3.id_caja=c.id) end as monto_cuenta,
			case when (select sum(c4.monto) from gasto  c4 where c4.id_caja=c.id) is null then 0 else (select sum(c4.monto) from gasto  c4 where c4.id_caja=c.id) end as monto_gasto,
			case when (select sum(c5.monto) from abono  c5 where c5.id_caja=c.id) is null then 0 else (select sum(c5.monto) from abono  c5 where c5.id_caja=c.id) end as monto_abono,
			c.estado ,
			c.fecha_abrir ,
			c.fecha_cierre,
			c.id_usuario   
			from caja c where c.id=?) tabla ");
				$query->execute(array($id)); 
				$row=$query->fetch(PDO::FETCH_OBJ);
				
				if($row)
				{
					$resultado=$row;
				}
				else
					{
						$resultado=-1;
					}
		}catch(PDOException $e)
		{ 
					echo $e; 
		}
	return $resultado;

   }


    
  public  function cierre_automatico_caja()
  {  
	  $resultado=-1;
	  try{ 
			$query = parent::getInstance()->getDb()->prepare("SELECT * from caja where estado='Abierta' ");
			$query->execute(); 
			//$row=$query->fetchAll();
				
			$cant=0;   
       
					while($fila=$query->fetch(PDO::FETCH_OBJ)) { 
						//echo 'cantidad:'.$cant;
						$caja=self::caja_por_id($fila->id);
						
						if($caja){ 
							$cierre_caja=self::cerrar_caja($caja->id,$caja->id_usuario,$caja->monto_cierre);
							if($cierre_caja==true){

								$sw_guardar=self::guardar($caja->id_usuario,$caja->caja,$caja->monto_cierre);

								$cant++;

							}
						}
					}
					$resultado=$cant;
			 

		}catch(PDOException $e)
		{ 
					echo 'try,'.$e; 
		}

   return $resultado;
  }

     public  function verificar_caja_abierta_por_id_usuario($id_usuario)
   {  
	   	$resultado=false;
	   	$query = parent::getInstance()->getDb()->prepare("SELECT * from caja where id_usuario=? and estado='Abierta'");
        $query->execute(array($id_usuario)); 
		$row=$query->fetch(PDO::FETCH_OBJ);
		 
		if($row)
		{
			$resultado=true;
		}
		else
			{
				$resultado=false;
			}
	return $resultado;
   }

 public  function id_caja_abierta_por_id_usuario($id_usuario)
   {  
	   	$resultado=0;
	   	$query = parent::getInstance()->getDb()->prepare("SELECT * from caja where id_usuario=? and estado='Abierta'");
        $query->execute(array($id_usuario)); 
		$row=$query->fetch(PDO::FETCH_OBJ);
		 
		if($row)
		{
			$resultado=$row->id;
		}
		else
			{
				$resultado=0;
			}
	return $resultado;
   }



 public  function lista()
   {  
   	$resultado=-1;
   	$query = parent::getInstance()
   	->getDb()
   	->prepare("SELECT c.*,u.usuario from caja c, usuario u 
   	where u.id=c.id_usuario 
   	order by c.fecha_abrir desc");
        $query->execute(); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	return $resultado;
   }


 public  function lista_por_id_usuario($id_usuario)
   {  
   	$resultado=-1;
   	$query = parent::getInstance()
   	->getDb()
   	->prepare("SELECT c.*,u.usuario from caja c, usuario u 
   	where u.id=c.id_usuario 
   	and  c.id_usuario=? 
   	order by c.fecha_abrir desc");
        $query->execute(array($id_usuario)); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	return $resultado;

   }

 public  function informe_cobro($id_usuario)
   {  
	   	$resultado=-1;
	   	try{
	   	$query = parent::getInstance()
	   	->getDb()
	   	->prepare("SELECT cc.id as id_caja_actual,
(select id from caja ic1 where ic1.id_usuario=? order by id desc limit 1,1) as id_caja_ultima,
case when (select monto_cierre from caja ic2 where ic2.id_usuario=?  order by id desc limit 1,1) is null then 0 ELSE 
(select monto_cierre from caja ic2 where ic2.id_usuario=?  order by id desc limit 1,1) end   as caja_ultima_liquidada,
case when (select fecha_cierre  from caja ic3 where ic3.id_usuario=?  order by id desc limit 1,1) is null then 0 else 
(select fecha_cierre  from caja ic3 where ic3.id_usuario=?  order by id desc limit 1,1) end as ultima_liquidada,
(select (tabla.monto_abrir+(tabla.monto_cuota)-tabla.monto_cuenta-tabla.monto_gasto+tabla.monto_abono) as monto_cierre  
from(select c.id,c.caja,
c.monto_abrir ,
case when (select sum(c1.monto) from cuota  c1 where c1.id_caja=c.id) is null then 0 else (select sum(c1.monto) from cuota  c1 where c1.id_caja=c.id) end as monto_cuota,
case when (select sum(c3.valor) from cuenta  c3 where c3.id_caja=c.id) is null then 0 else (select sum(c3.valor) from cuenta  c3 where c3.id_caja=c.id) end as monto_cuenta,
case when (select sum(c4.monto) from gasto  c4 where c4.id_caja=c.id) is null then 0 else (select sum(c4.monto) from gasto  c4 where c4.id_caja=c.id) end as monto_gasto,
case when (select sum(c5.monto) from abono  c5 where c5.id_caja=c.id) is null then 0 else (select sum(c5.monto) from abono  c5 where c5.id_caja=c.id) end as monto_abono 
from caja c where c.id_usuario=? ) tabla where tabla.id=cc.id) as caja_actual,
(select case when sum(cu.valor_diario)is null then 0 else sum(cu.valor_diario) end from cuota c, cuenta cu 
where c.id_cuenta =cu.id and c.id_usuario=? and c.estado='DEUDA' 
and date(c.fecha_pago) = date(now())) as estimado_cobrar,
(select sum(tabla.monto_cuota)+ sum(tabla.monto_abono) as monto_cierre 
from(select c.id,c.caja,
c.monto_abrir ,
case when (select sum(c1.monto) from cuota  c1 where c1.id_caja=c.id) is null then 0 else (select sum(c1.monto) from cuota  c1 where c1.id_caja=c.id) end as monto_cuota,
case when (select sum(c3.monto) from abono  c3 where c3.id_caja=c.id) is null then 0 else (select sum(c3.monto) from abono  c3 where c3.id_caja=c.id) end as monto_abono 
from caja c where c.id_usuario=? ) tabla where tabla.id=cc.id) as total_cobrado_liquidada,
(select (tabla.monto_cuota+tabla.monto_abono) as monto_cierre  
from(select c.id,c.caja,
c.monto_abrir ,
case when (select sum(c1.monto) from cuota  c1 where c1.id_caja=c.id and date(c1.fecha_registro_pago)=date(now())) is null then 0 else (select sum(c1.monto) from cuota  c1 where c1.id_caja=c.id and date(c1.fecha_registro_pago)=date(now())) end as monto_cuota,
case when (select sum(c3.monto) from abono  c3 where c3.id_caja=c.id and date(c3.fecha)=date(now())) is null then 0 else (select sum(c3.monto) from abono  c3 where c3.id_caja=c.id and date(c3.fecha)=date(now())) end as monto_abono
from caja c where c.id_usuario=? ) tabla where tabla.id=cc.id) as total_cobrado_dia,
case when (select sum(c3.valor) from cuenta  c3 where c3.id_caja=cc.id) is null then 0 else (select sum(c3.valor) from cuenta  c3 where c3.id_caja=cc.id) end as total_ventas,
case when (select sum(g.monto) from gasto g where g.id_caja=cc.id) is null then 0 
ELSE (select sum(g.monto) from gasto g where g.id_caja=cc.id) END AS gastos
from caja cc 
where cc.id_usuario =?
order by cc.id desc limit 1");

        $query->execute(array($id_usuario,$id_usuario,$id_usuario,$id_usuario,$id_usuario,$id_usuario,$id_usuario,$id_usuario,$id_usuario,$id_usuario)); 
		$row=$query->fetch(PDO::FETCH_OBJ);
		 
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	}catch(PDOException $e)
	{ 
				echo $e; 
	}
			
	return $resultado;
   }


   public  function lista_cliente_pendiente($id_caja,$id_usuario)
   {  
	/*
	SELECT cu.id as id_cuota,
		0 as id_abono,
		cu.id_cuenta,
		cl.*,
		(cuenta.valor_diario) as monto_pago,
		(select case when cuc.fecha_registro_pago is not null then cuc.fecha_registro_pago else now() end from cuota cuc where cl.id=cuc.id_cliente and date(cuc.fecha_registro_pago) = DATE_ADD(cuc.fecha_registro_pago, INTERVAL -1 DAY)) as fecha_ultimo_pago 
		from cliente cl, 
		cuota cu,
		cuenta 
		where  cuenta.id=cu.id_cuenta 
		and cl.id=cu.id_cliente  
		and cu.estado='DEUDA'
		AND date(cu.fecha_pago)=date(now())
		and cu.id_usuario=? 
		and cuenta.id_cliente not in(select id_cliente from notificacion where date(now())=fecha_notificacion and notificacion.id_cliente=cuenta.id_cliente)
		order by fecha_ultimo_pago asc
	*/
   	$resultado=-1;
   	try{ 
   	$query = parent::getInstance()
   	->getDb()
   	->prepare("SELECT 0 as id_cuota,
		0 as id_abono,
		cuenta.id as id_cuenta,
		cl.*,
		(cuenta.valor_diario) as monto_pago,
		(select case when cuc.fecha_registro_pago is not null then cuc.fecha_registro_pago else now() end from cuota cuc where cl.id=cuc.id_cliente and date(cuc.fecha_registro_pago) = DATE_ADD(cuc.fecha_registro_pago, INTERVAL -1 DAY)) as fecha_ultimo_pago 
		from cliente cl, 
		cuenta 
		where   cl.id=cuenta.id_cliente  
		and cuenta.deuda>0 
		and cuenta.id_usuario=? 
		and cuenta.id not in(select ab.id_cuenta from abono ab where ab.id_cuenta = cuenta.id and date(ab.fecha)=date(now()))
		and cuenta.id not in(select cuo.id_cuenta from cuota cuo where cuo.id_cuenta = cuenta.id and date(cuo.fecha_registro_pago)=date(now()))
		and cuenta.id_cliente not in(select id_cliente from notificacion where date(now())=date(fecha_notificacion) and notificacion.id_cliente=cuenta.id_cliente)
		order by fecha_ultimo_pago asc");
        $query->execute(array($id_usuario)); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	}catch(PDOException $e)
	{ 
				echo $e; 
	}
	return $resultado;
   }


   public  function lista_cliente_pendiente_administrador($id_caja,$id_usuario)
   {  
   	$resultado=-1;
   	try{ 
   	$query = parent::getInstance()
   	->getDb()
   	->prepare("SELECT 0 as id_cuota,
	   0 as id_abono,
	   cuenta.id as id_cuenta,
	   cl.*,
	   (cuenta.valor_diario) as monto_pago,
	   (select case when cuc.fecha_registro_pago is not null then cuc.fecha_registro_pago else now() end from cuota cuc where cl.id=cuc.id_cliente and date(cuc.fecha_registro_pago) = DATE_ADD(cuc.fecha_registro_pago, INTERVAL -1 DAY)) as fecha_ultimo_pago 
	   from cliente cl, 
	   cuenta 
	   where   cl.id=cuenta.id_cliente  
	   and cuenta.deuda>0  
	   and cuenta.id not in(select ab.id_cuenta from abono ab where ab.id_cuenta = cuenta.id and date(ab.fecha)=date(now()))
	   and  cuenta.id not in(select cuo.id_cuenta from cuota cuo where cuo.id_cuenta = cuenta.id and date(cuo.fecha_registro_pago)=date(now()))
		and cuenta.id_cliente not in(select id_cliente from notificacion where date(now())=date(fecha_notificacion) and notificacion.id_cliente=cuenta.id_cliente)
	   order by fecha_ultimo_pago asc");
        $query->execute(array($id_usuario)); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	}catch(PDOException $e)
	{ 
				echo $e; 
	}
	return $resultado;
   }

   public  function lista_cliente_cobro_dia($id_caja,$id_usuario,$parametrica)
   {  
   	$resultado=-1;
   	try{ 
   	$query = parent::getInstance()
   	->getDb()
   	->prepare("SELECT cu.id as id_cuota,
	   0 as id_abono,
	   cl.*,
	   (cu.monto) as monto_pago  
	   from caja c, 
	   cliente cl, 
	   cuota cu 
	   where cl.id=cu.id_cliente 
	   and c.id =cu.id_caja 
	    and date(cu.fecha_registro_pago)=date(now())
	   and cu.estado in('PAGADO')
		and c.id =?  
		union 
		SELECT 0 as id_cuota,
	   0 as id_abono,
	   cl.*,
	   (a.monto) as monto_pago  
	   from caja c, 
	   cliente cl, 
	   cuota cu,
	   abono a
	   where cl.id=cu.id_cliente 
	   and c.id =a.id_caja 
	   and a.id_cuenta =cu.id 
	    and date(a.fecha)=date(now()) 
		and c.id =? ");
        $query->execute(array($id_caja,$id_caja)); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	}catch(PDOException $e)
	{ 
				echo $e; 
	}
	return $resultado;
   }

   public  function lista_pagos_cobro_liquidada($id_caja,$id_usuario,$id_cliente)
   {  
   	$resultado=-1;
   	try{ 
   	$query = parent::getInstance()
   	->getDb()
   	->prepare("SELECT cu.id as id_cuota,
		0 as id_abono,
		cl.*,
		cu.monto as monto_pago,
		cu.fecha_registro_pago
		from caja c, 
		cliente cl, 
		cuota cu 
		where cl.id=cu.id_cliente 
		and c.id =cu.id_caja 
		and cu.estado='PAGADO'
		and c.id_usuario=? 
		and cl.id=?
		and year(date(cu.fecha_registro_pago))=year(date(now()))
		and week(date(cu.fecha_registro_pago))=week(date(now()))  
		order by cu.id asc");
        $query->execute(array($id_usuario,$id_cliente)); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	}catch(PDOException $e)
	{ 
				echo $e; 
	}
	return $resultado;
   }

public  function lista_cliente_cobro_liquidada($id_caja,$id_usuario,$parametrica)
   {  
   	$resultado=-1;
   	try{ 
   	$query = parent::getInstance()
   	->getDb()
   	->prepare("SELECT 0 as id_cuota,
		0 as id_abono,
		cl.*,
		sum(cu.monto) as monto_pago
		from caja c, 
		cliente cl, 
		cuota cu 
		where cl.id=cu.id_cliente 
		and c.id =cu.id_caja 
		and cu.estado='PAGADO'
		and c.id_usuario=? 
		and year(date(cu.fecha_registro_pago))=year(date(now()))
		and week(date(cu.fecha_registro_pago))=week(date(now())) 
		group by id_cuota,id_abono,id,ci,nombre,apellido,negocio,direccion,notificacion,telefono,latitud,longitud,fecha,id_usuario,estado 
		order by cu.id asc");
        $query->execute(array($id_usuario)); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	}catch(PDOException $e)
	{ 
				echo $e; 
	}
	return $resultado;
   }
 
   
  

   public static function guardar_bitacora($id_usuario,$tipo,$detalle)
   { 
	try{
		$usuario="";
		$query = parent::getInstance()->getDb()->prepare("SELECT * from usuario where id=?");
		$query->execute(array($id_usuario)); 
		$row=$query->fetch(PDO::FETCH_OBJ);
		 
		if($row)
		{
			$usuario=$row->usuario;
		}
   
	$consulta="INSERT INTO bitacora (usuario,id_usuario,tipo,detalle)
	values(?,?,?,?)";
	$comando=parent::getInstance()
	->getDb()
	->prepare($consulta);
	$comando->execute(array($usuario,$id_usuario,$tipo,$detalle)); 
	
	return true;
	}catch(PDOException $e)
	{ 
		echo $e;
	  return false;
	}
   }


public static function inversion_caja($id_usuario,$id_caja,$monto)
{
	   try{
		  $consulta="UPDATE caja  set monto_abrir=monto_abrir+ ? 
		  where id=? and estado='ABIERTA' ";
		  $comando=parent::getInstance()->getDb()->prepare($consulta);
		  $comando->execute(array($monto,$id_caja));
		  
		  return true;
		  }catch(PDOException $e)
		  { 
			  echo $e;
			return false;
		  }
		 
  

}

public  function utilidad($id_usuario,$id_usuario_buscar,$anio,$mes)
{  
	$resultado=-1;
try{
	$sql_condicion="";
	if($id_usuario_buscar!=0){
	  $sql_condicion.=" and id_usuario= ".$id_usuario_buscar;
	}
	if($mes!=0){
	  $sql_condicion.=" and month(fecha)= ".$mes;
	}
	if($anio!=0){
	  $sql_condicion.=" and year(fecha)= ".$anio;
	}

	$consulta="SELECT sum(interes) interes,sum(gasto) as gasto,sum(interes)-sum(gasto)as total  
	from (SELECT sum(interes)as interes,0 as gasto  FROM cuenta where deuda<=0 ".$sql_condicion."  
	union (SELECT 0 as interes,sum(monto)as gasto  from gasto where monto>0  ".$sql_condicion." ))tabla ";


	self::guardar_bitacora($id_usuario,'utilidad_consulta',$consulta);

	$query = parent::getInstance()->getDb()->prepare($consulta);
	 $query->execute(); 
	 $row=$query->fetchAll();
	   
		  if($row)
		  {
			  $resultado=$row;
		  }
		  else
			  {
				  $resultado=-1;
			  }
	  }catch(PDOException $e)
	  { 
		  self::guardar_bitacora($id_usuario,'utilidad_error',$e);
	  }
 return $resultado;

}


}


		

 ?>
