<?php 
require_once('Basededatos.php');

class Cliente extends Database
{
    
	public function Cliente()
	{
 		parent::Database();
 		
	}

	
	


 public static function guardar_cliente($ci,$nombre,$apellido,$negocio,$direccion,$telefono,$latitud,$longitud,$id_usuario)
  {
    if(self::existe_cliente_por_ci($ci)==false){
     		 try{
		    $consulta="INSERT cliente (ci,nombre,apellido,negocio,direccion,telefono,latitud,longitud,id_usuario)values(?,?,?,?,?,?,?,?,?)";
		    $comando=parent::getInstance()->getDb()->prepare($consulta);
		    $comando->execute(array($ci,$nombre,$apellido,$negocio,$direccion,$telefono,$latitud,$longitud,$id_usuario));
		    
		    return true;
		    }catch(PDOException $e)
		    { 
				self::guardar_bitacora($id_usuario,'error_cliente','Error al guardar el cliente ->'.$e);
				//echo $e;
		      return $e;
		    }
   		
    }else 
    {
      return false;
    }

  }

  public static function eliminar_cliente($id_cliente,$id_usuario)
  { 
     		 try{
		    $consulta="DELETE FROM  cliente where id=?";
		    $comando=parent::getInstance()->getDb()->prepare($consulta);
		    $comando->execute(array($id_cliente));
		    
		    return true;
		    }catch(PDOException $e)
		    { 
				self::guardar_bitacora($id_usuario,'eliminar_cliente','Error al eliminar el cliente ->'.$e);
				//echo $e;
		      return false;
		    }

  }

  /**
	* Obtiene el nro y contraseña para loguearse
	* a la base de datos
	* @param $nro    nro del usuario
	* @param $password    contraseña del usuario
	*/
 public static function actualizar_cliente($ci,$nombre,$apellido,$negocio,$direccion,$telefono,$latitud,$longitud,$id_cliente)
 {
 
     try{
	    $consulta="UPDATE cliente 
	    set  
	    ci=?,
		nombre=?,
		apellido=?,
		negocio=?,
		direccion=?,
		telefono=?,
		latitud=?,
	    longitud=?
	    where id=?";

	    $comando=parent::getInstance()->getDb()->prepare($consulta);
	    $comando->execute(array($ci,$nombre,$apellido,$negocio,$direccion,$telefono,$latitud,$longitud,$id_cliente));
	    return true;
    }catch(PDOException $e)
    {
    	echo $e;
      return false;
    }
}

public static function actualizar_cliente_notificacion($id_usuario,$id_cliente,$notificacion)
 {
 
     try{
	    $consulta="UPDATE cliente 
	    set  
	    notificacion=? 
	    where id=?";

	    $comando=parent::getInstance()->getDb()->prepare($consulta);
	    $comando->execute(array($notificacion,$id_cliente));
		//insertart notificacion
		$sq_notificacion=self::insertar_notificacion($id_usuario,$id_cliente,$notificacion);
	    return true;
    }catch(PDOException $e)
    {
    	echo $e;
      return false;
    }
}
 
public static function insertar_notificacion($id_usuario,$id_cliente,$notificacion)
 {
	try{
		$consulta="INSERT notificacion (id_usuario,id_cliente,notificacion,fecha_notificacion)values(?,?,?,date(now()))";
		$comando=parent::getInstance()->getDb()->prepare($consulta);
		$comando->execute(array($id_usuario,$id_cliente,$notificacion));
		
		return true;
		}catch(PDOException $e)
		{ 
			self::guardar_bitacora($id_usuario,'insertar_notificacion','Error al guardar notificacion ->'.$e);
			//echo $e;
		  return $e;
		}
}
 


 public  function lista_cliente($id_usuario)
   {  

		$query = parent::getInstance()->getDb()->prepare("SELECT * from usuario where id=?");
        $query->execute(array($id_usuario)); 
		$row=$query->fetch(PDO::FETCH_OBJ);
		 
		$tipo="";
		if($row)
		{
			$tipo=$row->tipo;
		}

		$resultado=-1;

		$sql="";
		if($tipo=="ADMINISTRADOR"){
			$sql="SELECT id, ci, nombre, apellido, negocio, direccion, IFNULL(notificacion,'') AS notificacion, telefono, latitud, longitud, fecha, id_usuario, estado 
			from cliente order by nombre asc";
		}else{
			$sql="SELECT id, ci, nombre, apellido, negocio, direccion, IFNULL(notificacion,'') AS notificacion, telefono, latitud, longitud, fecha, id_usuario, estado 
			from cliente where id_usuario=".$id_usuario." order by nombre asc";
		}

   		$query = parent::getInstance()->getDb()->prepare($sql);
        $query->execute(); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		} else{
				$resultado=-1;
		}

	return $resultado;
   }

 
  public static function existe_cliente_por_ci($ci)
  {
    $resultado=false;
     try{ 
    $consulta="SELECT ci from cliente WHERE  ci= ?  limit 1 ";
    $comando=parent::getInstance()->getDb()->prepare($consulta);
    $comando->execute(array($ci));
    $row=$comando->fetch(PDO::FETCH_ASSOC);
      
            if($row)
            {
              $resultado=true;
            }   
            else{
              $resultado=false;
            }   
    } catch (PDOException $e) {
		self::guardar_bitacora($id_usuario,'existe_cliente','Error al buscar cliente ->'.$e);
      $resultado=false;
     }
    return $resultado;
    }
  
  public  function distancia_cliente_cerca_usuario($id_usuario,$latitud,$longitud)
	  {
	  	try{
	  	$distancia=0;
	  	//$consulta="SELECT distancia_entre_dos_puntos(c.latitud,c.longitud,".$latitud.",".$longitud.") as distancia ,c.*  from cliente c order by distancia asc ";
		  $consulta="SELECT 0 as distancia ,c.*  from cliente c where id_usuario=? order by distancia asc ";
			
				$comando=parent::getInstance()->getDb()->prepare($consulta);
				$comando->execute(array($id_usuario));
				$row=$comando->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	 } catch (PDOException $e) {
      $resultado=-1;
     }
    return $resultado;
    }


	public static function guardar_bitacora($id_usuario,$tipo,$detalle)
   { 
	try{
		$usuario="";
		$query = parent::getInstance()->getDb()->prepare("SELECT * from usuario where id=?");
        $query->execute(array($id_usuario)); 
		$row=$query->fetch(PDO::FETCH_OBJ);
		 
		if($row)
		{
			$usuario=$row->usuario;
		}

	$consulta="INSERT INTO bitacora (usuario,id_usuario,tipo,detalle)
	values(?,?,?,?)";
	$comando=parent::getInstance()
	->getDb()
	->prepare($consulta);
	$comando->execute(array($usuario,$id_usuario,$tipo,$detalle)); 
	
	return true;
	}catch(PDOException $e)
	{ 
		echo $e;
	  return false;
	}
   }

}


		

 ?>
